;--------------------------------------------------------
;AutoIt Version: 3.2.4.9
;
;Script Author: Andrew Calcutt
;Script Start Date: 07/09/2007
;Last Modified: 07/21/2007
;Script Name: Vistumbler
;Script Function: A vista version of Netstumbler useing the Windows service
;Script Ver: 2.1 Beta
;--------------------------------------------------------
#include <File.au3>
#include <Array.au3>
#Include <process.au3>
#include <GuiConstants.au3>
#Include <GuiListView.au3>

If @OSVersion <> "WIN_VISTA" Then MsgBox(0, "Warning", "This Program will only run in Vista. It relies on a netsh command that is not avalible in older versions of windows")

$tempfile = 'Vistumbler_Temp.txt'
Dim $Latitude = 'N 0.0000000'
Dim $Longitude = 'E 0.0000000'
Dim $ScanGPS = 0
Dim $Scan = 0
Dim $Exit = 0
Dim $TempFileArray, $OpenArray, $oMyError, $temp, $LatTest, $gps, $NetComm, $CommPort, $msgdisplay
Dim $SSID, $NetworkType, $Authentication, $Encryption, $BSSID, $Signal, $RadioType, $Channel, $BasicTransferRates, $OtherTransferRates, $display, $ActiveBSSIDs
;Load Settings
$settings = 'vistumbler_settings.ini'
$saved_comport = IniRead($settings, 'Vistumbler', 'ComPort', 8)
$saved_baud = IniRead($settings, 'Vistumbler', 'Baud', 4800)
$saved_sleeptime = IniRead($settings, 'Vistumbler', 'Sleeptime', 1000)

;GUI CREATION
Opt("GUIOnEventMode", 1)  ; Change to OnEvent mode
$Form1_1 = GUICreate("Vistumbler V2.1 Beta- By Andrew Calcutt", 875, 604, -1, -1, BitOR($WS_OVERLAPPEDWINDOW, $WS_CLIPSIBLINGS))
$ListView1 = GUICtrlCreateListView("SSID                          |Network Type|Authentication|Encryption|BSSID|Signal|Radio Type|Channel|Basic Transfer Rates|Other Transfer Rates|Latitude|Longitude|First Active|Last Active|Active", 0, 72, 873, 529, $LVS_REPORT)
$ScanButton = GUICtrlCreateButton("Scan", 10, 8, 65, 17, 0)
$SaveButton = GUICtrlCreateButton("Save As TXT", 155, 8, 80, 17, 0)
$SaveKML = GUICtrlCreateButton("Save As KML", 235, 8, 80, 17, 0)
$UseGPS = GUICtrlCreateCheckbox("Use GPS", 8, 40, 65, 17)
$Load = GUICtrlCreateButton("Load From TXT", 75, 8, 80, 17, 0)
GUICtrlCreateLabel("Baud:", 170, 45, 35, 17)
$BAUD = GUICtrlCreateCombo("4800", 200, 40, 100, 25)
GUICtrlSetData(-1,"9600|14400|19200|38400|57600|115200", $saved_baud)
GUICtrlCreateLabel("COM:", 95, 45, 30, 17)
$ComPort = GUICtrlCreateCombo("1", 125, 40, 40, 21)
GUICtrlSetData(-1,"2|3|4|5|6|7|8|9|10|11|12|13|14|15|16|17|18|19|20", $saved_comport)
$GuiLat = GUICtrlCreateLabel("Latitude:", 320, 40, 130, 17)
$GuiLon = GUICtrlCreateLabel("Longitude:", 450, 40, 130, 17)
$RefLoopLabel = GUICtrlCreateLabel("Refresh Loop Time(mS):", 328, 8, 118, 17)
$sleeptime = GUICtrlCreateInput($saved_sleeptime, 448, 8, 49, 21)
$timediff = GUICtrlCreateLabel("Actual Loop Time(mS):", 504, 8, 200, 17)
$msgdisplay = GUICtrlCreateLabel("GPS Message:", 580, 40, 250, 17)
$ActiveAPs = GUICtrlCreateLabel("Active APs:", 710, 8, 120, 17)

;Button Events
GUISetOnEvent($GUI_EVENT_CLOSE, "CLOSEClicked")
GUICtrlSetOnEvent($ScanButton, "ScanToggle")
GUICtrlSetOnEvent($UseGPS, "GpsToggle")
GUICtrlSetOnEvent($SaveButton, "SaveList")
GUICtrlSetOnEvent($Load, "LoadList")
GUICtrlSetOnEvent($SaveKML, "SaveToKML")
GUISetState(@SW_SHOW)
;END GUI CREATION
$refresh_gps = TimerInit() ;Start timer for gps refresh
While 1
	$begin = TimerInit() ;Start $begin timer, used to measure loop time
	If $Scan = 1 Or $ScanGPS = 1 Then
		;Scan for GPS if GPS enabled
		If $ScanGPS = 1 Then _GetGPS(GUICtrlRead($ComPort), GUICtrlRead($BAUD))
		;If Exit Flag = 1 Then Exit Program
		If $Exit = 1 Then Exit
		;Reset Position to default if a new location has not been found in 60 seconds
		If TimerDiff($refresh_gps) > 60000 Then
			$Latitude = 'N 0.0000000'
			$Longitude = 'E 0.0000000'
			$refresh_gps = TimerInit()
		EndIf
		;Set GPS Location Data in GUI
		GUICtrlSetData($msgdisplay, 'Seconds Since GPS Update: ' & Round(TimerDiff($refresh_gps) / 1000) & '/60')
		GUICtrlSetData($GuiLat, 'Latitude: ' & $Latitude)
		GUICtrlSetData($GuiLon, 'Longitude: ' & $Longitude)
		;Scan for Access Points if scanning enabled
		If $Scan = 1 Then _ScanAccessPoints()
		;Start - Reset non-active entries
		$Active_BSSID_Array = StringSplit($ActiveBSSIDs, '|')
		GUICtrlSetData($ActiveAPs, 'Active APs: ' & $Active_BSSID_Array[0] - 1 & ' / ' & _GUICtrlListViewGetItemCount($ListView1))
		$ActiveBSSIDs = ''
		For $active = 0 To _GUICtrlListViewGetItemCount($ListView1)
			$foundactive = 0
			For $activearrayloop = 2 To $Active_BSSID_Array[0]
				If $Active_BSSID_Array[$activearrayloop] = _GUICtrlListViewGetItemText($ListView1, $active, 4) Then
					$foundactive = 1
					ExitLoop
				EndIf
			Next
			If $foundactive = 0 Then _GUICtrlListViewSetItemText($ListView1, $active, 14, "")
		Next
		;End - Reset non-active entries
		If TimerDiff($begin) <= GUICtrlRead($sleeptime) Then Sleep(GUICtrlRead($sleeptime) - TimerDiff($begin)); If time difference is less then time taken for loop, sleep remaining time
	Else
		Sleep(10)
	EndIf
	GUICtrlSetData($timediff, 'Actual Loop Time: ' & Round(TimerDiff($begin)) & 'mS')
WEnd

Func _ScanAccessPoints()
	_RunDOS("netsh wlan show networks mode=bssid > " & $tempfile) ;copy the output of the 'netsh wlan show networks mode=bssid' command to the temp file
	_FileReadToArray($tempfile, $TempFileArray);read the tempfile into the '$TempFileArray' Araay
	FileDelete($tempfile)
	For $loop = 1 To $TempFileArray[0]; loop through the temp file array u
		If StringInStr($TempFileArray[$loop], "SSID") Then
			Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '' ;Clear Variables
			While StringInStr($TempFileArray[$loop + 1], "SSID") <> 1
				$temp = StringSplit($TempFileArray[$loop], ":")
				If IsArray($temp) Then ; Strip Data from line
					If StringInStr($temp[1], "BSSID") Then
						$BSSID = StringUpper($temp[2] & ':' & $temp[3] & ':' & $temp[4] & ':' & $temp[5] & ':' & $temp[6] & ':' & $temp[7])
					ElseIf StringInStr($temp[1], "SSID") Then
						$SSID = $temp[2]
					ElseIf StringInStr($temp[1], "Network type") Then
						$NetworkType = $temp[2]
					ElseIf StringInStr($temp[1], "Authentication") Then
						$Authentication = $temp[2]
					ElseIf StringInStr($temp[1], "Encryption") Then
						$Encryption = $temp[2]
					ElseIf StringInStr($temp[1], "Signal") Then
						$Signal = $temp[2]
					ElseIf StringInStr($temp[1], "Radio Type") Then
						$RadioType = $temp[2]
					ElseIf StringInStr($temp[1], "Channel") Then
						$Channel = $temp[2]
					ElseIf StringInStr($temp[1], "Basic Rates") Then
						$BasicTransferRates = $temp[2]
					ElseIf StringInStr($temp[1], "Other Rates") Then
						$OtherTransferRates = $temp[2]
					EndIf
				EndIf
				If ($loop + 1) >= $TempFileArray[0] Then ExitLoop ;If Adding 1 to the loop will make it greater than the array size, ExitLoop so no crash happens
				$loop += 1
			WEnd
			If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
				$arraysearch = -1
				$itemcount = _GUICtrlListViewGetItemCount($ListView1)
				For $findloop = 0 To $itemcount; Find BSSID in existing list
					If _GUICtrlListViewGetItemText($ListView1, $itemcount - $findloop, 4) = $BSSID And _GUICtrlListViewGetItemText($ListView1, $itemcount - $findloop, 0) =  $SSID Then
						$arraysearch = $itemcount - $findloop
						ExitLoop
					EndIf
				Next

				If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
					GUICtrlCreateListViewItem($SSID & '|' & $NetworkType & '|' & $Authentication & '|' & $Encryption & '|' & $BSSID & '|' & $Signal & '|' & $RadioType & '|' & $Channel & '|' & $BasicTransferRates & '|' & $OtherTransferRates & '|' & $Latitude & '|' & $Longitude & '|' & @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC & '|' & @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC & '|' & "Active", $ListView1)
				Else
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 0, $SSID)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 1, $NetworkType)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 2, $Authentication)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 3, $Encryption)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 4, $BSSID)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 5, $Signal)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 6, $RadioType)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 7, $Channel)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 8, $BasicTransferRates)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 9, $OtherTransferRates)
					If $Latitude <> 'N 0.0000000' And $Latitude <> '' Then _GUICtrlListViewSetItemText($ListView1, $arraysearch, 10, $Latitude)
					If $Longitude <> 'E 0.0000000' And $Longitude <> '' Then _GUICtrlListViewSetItemText($ListView1, $arraysearch, 11, $Longitude)
					;_GUICtrlListViewSetItemText($ListView1, $arraysearch, 12, @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 13, @MON & '-' & @MDAY & '-' & @YEAR & ' ' & @HOUR & ':' & @MIN & ':' & @SEC)
					_GUICtrlListViewSetItemText($ListView1, $arraysearch, 14, "Active")
				EndIf
				$ActiveBSSIDs &= '|' & $BSSID ; Add found BSSID into $ActiveBSSIDs string for use later displaying Active BSSIDs at end of file read
			EndIf
		EndIf
	Next
EndFunc   ;==>_ScanAccessPoints

Func _GetGPS($CommPort = '8', $sBAUD = '4800', $s1 = 'N', $s2 = '8', $s3 = '1')
	$CommSettings = $sBAUD & ',' & $s1 & ',' & $s2 & ',' & $s3
	;	Create NETComm.ocx object
	$NetComm = ObjCreate("NETCommOCX.NETComm")
	If IsObj($NetComm) = 0 Then ;Is $netcom is not an object then it was not able to open the comport
		;GUICtrlSetData($msgdisplay, "Error reading Com Port " & $CommPort)
	Else
		;Set object settings
		With $NetComm
			.CommPort = $CommPort ;Set port number
			.Settings = $CommSettings ;Set port settings
			.InputLen = 0 ;reads entire buffer
			.InputMode = 0 ;reads in text mode
			.HandShaking = 3 ;uses both RTS and Xon/Xoff handshaking
			.PortOpen = "True"
		EndWith
		
		$LatTest = 0
		$timeout = TimerInit()
		While 1 ;Loop to extract gps data untill location is found or timout time is reached
			$maxtime = GUICtrlRead($sleeptime) * 0.8
			If $maxtime < 800 Then $maxtime = 800
			
			$Buffer = $NetComm.InBufferCount
			If $Buffer > 100 And $LatTest = 0 And TimerDiff($timeout) < $maxtime Then
				$inputdata = $NetComm.inputdata
				$gps = StringSplit($inputdata, "$")
				For $readloop = 1 To $gps[0]
					If StringInStr($gps[$readloop], "GPGGA") Then
						_GetData($gps[$readloop])
						If $LatTest = 1 Then ExitLoop
						If TimerDiff($timeout) > $maxtime Then ExitLoop
					EndIf
				Next
				If $LatTest = 1 Then
					$refresh_gps = TimerInit()
					ExitLoop
				EndIf
			EndIf

			If TimerDiff($timeout) > $maxtime Then
				GUICtrlSetData($msgdisplay, 'GPS Timeout')
				ExitLoop
			EndIf
			Sleep($maxtime / 100)
		WEnd
		
		;Close the COM Port
		With $NetComm
			.CommPort = $CommPort ;Set port number
			.PortOpen = "False" ;Closes specified COM port
		EndWith
	EndIf
EndFunc   ;==>_GetGPS

;Read GPS Receiver Data
Func _GetData($GpsData)
	GUICtrlSetData($msgdisplay, $GpsData)
	$data = StringSplit($GpsData, ",")
	If $data[0] > 9 Then
		;Convert to Min/Sec to Decimal Latitude
		$lat = StringSplit($data[3], ".")
		$latD = StringMid((StringRight($lat[1], 2) & "." & StringRight($lat[2], 4)) / 60, 2, 10)
		;Convert to Min/Sec to Decimal Longitude
		$lon = StringSplit($data[5], ".")
		$lonD = StringMid((StringRight($lon[1], 2) & "." & StringRight($lon[2], 4)) / 60, 2, 10)
		;Set Location Variables
		$ufLat = StringLeft($lat[1], StringLen($lat[1]) - 2) & $latD
		$ufLon = StringLeft($lon[1], StringLen($lon[1]) - 2) & $lonD
		$Latitude = $data[4] & ' ' & StringFormat('%0.7f', $ufLat);set latitude
		$Longitude = $data[6] & ' ' & StringFormat('%0.7f', $ufLon);set longitude
		If $Latitude <> '' Then $LatTest = 1
	EndIf
EndFunc   ;==>_GetData
;-------------------------------------------------------------------------------------------------------------------------------
;                                                       BUTTONS
;-------------------------------------------------------------------------------------------------------------------------------
Func ScanToggle()
	If $Scan = 1 Then
		$Scan = 0
		GUICtrlSetData($ScanButton, "Scan")
	Else
		$Scan = 1
		GUICtrlSetData($ScanButton, "Stop")
	EndIf
EndFunc   ;==>ScanToggle

Func GpsToggle()
	If $ScanGPS = 1 Then
		$ScanGPS = 0
	Else
		$ScanGPS = 1
	EndIf
EndFunc   ;==>GpsToggle

Func CLOSEClicked()
	FileDelete($tempfile)
	IniWrite($settings, 'Vistumbler', 'ComPort', GUICtrlRead($ComPort))
	IniWrite($settings, 'Vistumbler', 'Baud', GUICtrlRead($BAUD))
	IniWrite($settings, 'Vistumbler', 'Sleeptime', GUICtrlRead($sleeptime))
	If $ScanGPS = 1 Then
		$ScanGPS = 0
		$Exit = 1
	Else
		Exit
	EndIf
EndFunc   ;==>CLOSEClicked

Func SaveList()
	$file = FileSaveDialog("Output File", @ScriptDir, 'Text (*.txt)')
	If @error <> 1 Then
		If StringInStr($file, '.txt') = 0 Then $file = $file & '.txt'
		For $save = 0 To _GUICtrlListViewGetItemCount($ListView1)
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $save & ' / ' & _GUICtrlListViewGetItemCount($ListView1))
			FileWriteLine($file, _GUICtrlListViewGetItemText($ListView1, $save, 0) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 1) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 2) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 3) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 4) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 5) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 6) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 7) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 8) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 9) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 10) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 11) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 12) & '|' & _GUICtrlListViewGetItemText($ListView1, $save, 13))
		Next
		MsgBox(0, 'Done', 'Saved as: "' & $file & '"')
		GUICtrlSetData($msgdisplay, '')
	EndIf
EndFunc   ;==>SaveList

Func LoadList()
	$file = FileOpenDialog("Output File", @ScriptDir, 'Text (*.txt)')
	If @error <> 1 Then
		If StringInStr($file, '.txt') = 0 Then $file = $file & '.txt'
		_FileReadToArray($file, $OpenArray)
		For $open = 1 To $OpenArray[0] - 1
			GUICtrlSetData($msgdisplay, 'Loading Line ' & $open & ' / ' & $OpenArray[0] - 1)
			$loadlist = StringSplit($OpenArray[$open], '|')
			If IsArray($loadlist) Then
				Dim $SSID = '', $NetworkType = '', $Authentication = '', $Encryption = '', $BSSID = '', $Signal = '', $RadioType = '', $Channel = '', $BasicTransferRates = '', $OtherTransferRates = '', $LoadLatitude = '', $LoadLongitude = '', $FirstActive = '', $LastActive = '';Clear Variables
				$SSID = $loadlist[1]
				$NetworkType = $loadlist[2]
				$Authentication = $loadlist[3]
				$Encryption = $loadlist[4]
				$BSSID = $loadlist[5]
				$Signal = $loadlist[6]
				$RadioType = $loadlist[7]
				$Channel = $loadlist[8]
				$BasicTransferRates = $loadlist[9]
				$OtherTransferRates = $loadlist[10]
				$LoadLatitude = $loadlist[11]
				$LoadLongitude = $loadlist[12]
				$FirstActive = $loadlist[13]
				$LastActive = $loadlist[14]
				
				If $BSSID <> '' Then ; If Mac Address(BSSID) was found write data into
					
					$arraysearch = -1
					$itemcount = _GUICtrlListViewGetItemCount($ListView1)
					For $findloop = 0 To $itemcount; Find BSSID in existing list
						If _GUICtrlListViewGetItemText($ListView1, $itemcount - $findloop, 4) = $BSSID And _GUICtrlListViewGetItemText($ListView1, $itemcount - $findloop, 0) =  $SSID Then
							$arraysearch = $itemcount - $findloop
							;msgbox(0, _GUICtrlListViewGetItemText($ListView1, $itemcount - $findloop, 4), $BSSID)
							ExitLoop
						EndIf
					Next

					If $arraysearch = -1 Then ;If BSSID is not found, add it - Else - Update old entry
						GUICtrlCreateListViewItem($SSID & '|' & $NetworkType & '|' & $Authentication & '|' & $Encryption & '|' & $BSSID & '|' & $Signal & '|' & $RadioType & '|' & $Channel & '|' & $BasicTransferRates & '|' & $OtherTransferRates & '|' & $LoadLatitude & '|' & $LoadLongitude & '|' & $FirstActive & '|' & $LastActive & '|' & '', $ListView1)
					Else
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 0, $SSID)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 1, $NetworkType)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 2, $Authentication)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 3, $Encryption)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 4, $BSSID)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 5, $Signal)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 6, $RadioType)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 7, $Channel)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 8, $BasicTransferRates)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 9, $OtherTransferRates)
						If _GUICtrlListViewGetItemText($ListView1, $arraysearch, 10) = 'N 0.0000000' Or _GUICtrlListViewGetItemText($ListView1, $arraysearch, 10) = '' Then _GUICtrlListViewSetItemText($ListView1, $arraysearch, 10, $LoadLatitude)
						If _GUICtrlListViewGetItemText($ListView1, $arraysearch, 11) = 'E 0.0000000' Or _GUICtrlListViewGetItemText($ListView1, $arraysearch, 11) = '' Then _GUICtrlListViewSetItemText($ListView1, $arraysearch, 11, $LoadLongitude)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 12, $FirstActive)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 13, $LastActive)
						_GUICtrlListViewSetItemText($ListView1, $arraysearch, 14, '')
					EndIf
				EndIf
			EndIf
		Next
		MsgBox(0, 'Done', 'Load of file: "' & $file & '" complete')
		GUICtrlSetData($msgdisplay, '')
	EndIf
EndFunc   ;==>LoadList

Func SaveToKML()
	$kml = FileSaveDialog("Google Earth Output File", @ScriptDir, 'Google Earth (*.kml)')
	If @error <> 1 Then
		If StringInStr($kml, '.kml') = 0 Then $kml = $kml & '.kml'
		FileDelete($kml)
		$file = '<?xml version="1.0" encoding="utf-8"?>' & @CRLF _
				 & '<kml xmlns="http://earth.google.com/kml/2.0">' & @CRLF _
				 & '<Document>' & @CRLF _
				 & '<Style id="secureStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://mboffin.com/earthstumbler/wap-secure.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Style id="openStyle">' & @CRLF _
				 & '<IconStyle>' & @CRLF _
				 & '<scale>.5</scale>' & @CRLF _
				 & '<Icon>' & @CRLF _
				 & '<href>http://mboffin.com/earthstumbler/wap-open.png</href>' & @CRLF _;image from EarthStubler
				 & '</Icon>' & @CRLF _
				 & '</IconStyle>' & @CRLF _
				 & '</Style>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<description>Vistumbler - By Andrew Calcutt</description>' & @CRLF _
				 & '<name>NetstublerToKML</name>' & @CRLF _
				 & '<Folder>' & @CRLF _
				 & '<name>Access Points</name>' & @CRLF _
				 & '<description>Access points found</description>' & @CRLF
		
		
		For $i = 0 To _GUICtrlListViewGetItemCount($ListView1)
			GUICtrlSetData($msgdisplay, 'Saving Line ' & $i & ' / ' & _GUICtrlListViewGetItemCount($ListView1))
			If _GUICtrlListViewGetItemText($ListView1, $i, 11) <> '' And _GUICtrlListViewGetItemText($ListView1, $i, 11) <> 'N 0.0000000' Then
				$file &= '<Placemark>' & @CRLF _
						 & '<name></name>' & @CRLF _
						 & '<description><![CDATA[<b>SSID: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 0) & '<br /><b>BSSID: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 4) & '<br /><b>Network Type </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 1) & '<br /><b>Radio Type: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 6) & '<br /><b>Channel: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 7) & '<br /><b>Authentication: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 2) & '<br /><b>Encryption</b>' & _GUICtrlListViewGetItemText($ListView1, $i, 3) & '<br /><b>Basic Rates: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 8) & '<br /><b>Other Rates: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 9) & '<br /><b>First Seen: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 12) & '<br /><b>Last Seen: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 13) & '<br /><b>Signal: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 5) & '<br /><b>Longitude: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 11) & '<br /><b>Latitude: </b>' & _GUICtrlListViewGetItemText($ListView1, $i, 10) & '<br />]]></description>'
				
				If _GUICtrlListViewGetItemText($ListView1, $i, 2) = " Open" And _GUICtrlListViewGetItemText($ListView1, $i, 3) = " None " Then
					$file &= '	<styleUrl>#openStyle</styleUrl>' & @CRLF
				Else
					$file &= '	<styleUrl>#secureStyle</styleUrl>' & @CRLF
				EndIf
				
				$file &= '<Point>' & @CRLF _
						 & '<coordinates>' & StringReplace(StringReplace(StringReplace(_GUICtrlListViewGetItemText($ListView1, $i, 11), 'W', '-'), 'E', ''), ' ', '') & ',' & StringReplace(StringReplace(StringReplace(_GUICtrlListViewGetItemText($ListView1, $i, 10), 'S', '-'), 'N', ''), ' ', '') & ',0</coordinates>' & @CRLF _
						 & '</Point>' & @CRLF _
						 & '</Placemark>' & @CRLF
			EndIf
		Next
		
		$file &= '</Folder>' & @CRLF _
				 & '</Folder>' & @CRLF _
				 & '</Document>' & @CRLF _
				 & '</kml>' & @CRLF
		
		;MsgBox(0, '', $file)
		
		FileWrite($kml, $file)
		MsgBox(0, 'Done', 'Saved as: "' & $kml & '"')
		GUICtrlSetData($msgdisplay, '')
	EndIf
EndFunc   ;==>SaveToKML